      program pearlite
	  integer loop,i,j,m,p,option,choice,w,p1,p2,p3,p4,r,s,t
 	  real carbon,c_cem,c_fer
	  real coef,coef1,coef2,coef3,coef4,coe,coef5,coef7,d_coef
	  real af_ac,a_f_mn,c_f_mn
	  real tempf(1000),af_fe(1000),af_mn(1000),af_c(1000)
	  real tempf1(1000),ac_fe(1000),ac_mn(1000),ac_c(1000)
	  real tempf2(1000),fa_fe(1000),fa_mn(1000),fa_c(1000)
	  real tempf3(1000),ca_fe(1000),ca_mn(1000),ca_c(1000)
	  real df_cf,ddash1,ddash2,del_f,k,h,ddash,del_e,v1,v2
	  real v,v_gb,stor,stor1,st_mn,st_mn1,st_mn2,st_mn3,k_gb,v3,v4,v5,st_c,st_c1
	  real c_f_c,c_fe(1000),c_c(1000),acti_c
	  real del_T,temp,teqm,teqm1,si_fc,slope,z1,df_av
	  real del_hm,del_vm,velo,delta,factor,lamda,lamfer,lamcem
	  real Mn,Cr,Si,f_fe(1000),f_c(1000),D(1000)
	  real eta,molfra,ans,d_avg,part_c,vcgb,dcgb,d_eff
	  real temp_1(1000),a_fe(1000),a_c(1000),temp_2(1000)
	  real temp_3(1000),a1_fe(1000),a1_c(1000),temp_4(1000)
	  real var1,var2,var3,var4,res1,res2,act,R1,CG,CG1,var1_m,var3_m
	 
	  del_f=21230
	  h=6.63E-34
	  z1=12
      c_cem=6.67
	  c_fer=0.025
	  teqm=1000
	  
	  
	  open (unit = 22, file = 'fa_a_c.txt', status='old')
	  open (unit = 42, file = 'fa_f_c.txt', status='old')
	  open (unit = 32, file = 'ca_a_c.txt', status='old')
	  open (unit = 72, file = 'ca_c_c.txt', status='old')
      open (unit = 1,  file = 'output.txt', access='append')
c      open (unit = 113, file = 'diff_fn.txt')
c	  **********************************************************   
	  
	  print *,'Enter the chemical composition:'
	    
	    print *,'Carbon'
	    read *,carbon
	    write(1,31)
   31   FORMAT('------------------------------------------')
	    write(1,34),'Temperature','Growth rate'
   34   FORMAT(X,A,7X,A)
   
   		write(1,37),'(C)','(m s-1)'
   37   FORMAT(4X,A,15X,A)
    	write(1,38)
   38   FORMAT('------------------------------------------')
   
	   do 61 loop=1,9
	   
	   print *, 'enter the temperature :'
	   read *, temp
	   
	   If (temp .GE. teqm) then
	   print *, 'Please enter temp lesser than teqm:'
	   endif
c	  **********************************************************	    
	   do 200 r=1,600
	    read(22,*,end=201) temp_1(r),a_fe(r),a_c(r)
	    
	    if (temp_1(r) .EQ. temp) then 
			
	  		var1=a_c(r)*100
c           a_c(r) is multiplied by 100 to convert mass fraction into mass	  		
	  		
	    endif
	    
  200 enddo  
  201 endfile 22
	  rewind 22	    
	   
c	  *********************************************************
		do 300 s=1,600
		read(42,*,end=301) temp_2(s),f_fe(s),f_c(s)

		if (temp_2(s) .EQ. temp) then 

	  		var2=f_c(s)*100
c           f_c(p2) is multiplied by 100 to convert mass fraction into mass	  		
	  		
	    endif

  300 enddo
  301 endfile 42
	   rewind 42
	   
c	  **********************************************************
		do 400 t=1,600
		read(32,*,end=401) temp_3(t),a1_fe(t),a1_c(t)

		
		if (temp_3(t) .EQ. temp) then 

	  		var3=a1_c(t)*100
c           a1_c(p3) is multiplied by 100 to convert mass fraction into mass	  		
	  		
	    endif
		
  400 enddo	
  401 endfile 32
	  rewind 32
c	  *********************************************************	
      
		do 500 p4=1,600
		read(72,*,end=501) temp_4(p4),c_fe(p4),c_c(p4)	
	
		if (temp_4(p4) .EQ. temp) then 

	  		var4=c_c(p4)*100
c           c_c(p4) is multiplied by 100 to convert mass fraction into mass	  		
	  		
	    endif
	
  500 enddo
  501 endfile 72	
		rewind 72
c	  *********************************************************		


c       res1 and res2 calculates the diff. in interfacial compositions in Fe-C alloy
c	  *********************************************************		
       res1=var1-var3
	   res2=var4-var2
       
       
        call mol_frac_c(var1,var3,var1_m,var3_m)
c      		calculates the mol_fraction of carbon in austenite
c           var1 is the carbon in austenite in wt%    
       

      		    
 		call diff_calc(var1_m,var3_m,carbon,res1,res2,temp,d_avg)
 		    
c      		calculates the pearlite growth rate using volume diffusivity of C in austenite
c			call boundary_diff_c(d_avg,temp,part_c,res1,res2,vcgb)
c      		calculates the pearlite growth rate using boundary diffusivity of C in austenite			
			
	    call mixed_growth(temp,carbon,d_avg,res1,res2,velo)
 			 print *,'the pearlite growth rate in m s-1 is:', velo
 			 
 	
 	    write(1,33),temp-273,velo	
   
   33   format(f6.1,e22.3)
	     
   61  enddo 
      	
	
	  close(22)
	  close(42)
	  close(32)
	  close(72)
	  close(1)
c	  close(113)
	  stop
	  end
      
c    *******************************************************************
      
      subroutine diff_calc(var1_m,var3_m,carbon,res1,res2,temp,d_avg)
      real v1,v2,v,lamda,lamcem,lamfer,phi
	  real d_eff,delta
	  delta=2.5e-10
	  del_vm=7.1E-6
	  del_e=8352
	  k=1.38E-23
	 


            call phi_c(del_e,k,temp,phi)
c			calculates the value of sigma:site exclusion probability, used in calculation of eta
            
            
            call act_c(var1_m,temp,del_e,acti_c)
c           calculates the activity of carbon in austenite using a quasi chemical model:MAP             
c			print *,'the activity is:',acti_c
			
			call DCG(var1_m,del_e,temp,R,slope)
c			calculates the differential of activity of carbon in austenite           
c            print *, 'the slope is:',slope
       		    			  
	  		call DIFF(temp,var1_m,var3_m,del_e,acti_c,slope,phi,d_avg)
c	        print *, 'the weighted avg. diff coef in cm2/s is:',d_avg
	        

	  end

c    *********************************************************************
		subroutine mol_frac_c(var1,var3,var1_m,var3_m)
	 	real wt_fe,fe_mol,c_mol,wt_fe1,fe_mol1,c_mol1
	   
		wt_fe=100-var1
		fe_mol=wt_fe/55.8
		c_mol=var1/12.01
		var1_m=c_mol/(fe_mol+c_mol)
		
		wt_fe1=100-var3
		fe_mol1=wt_fe1/55.8
		c_mol1=var3/12.01
		var3_m=c_mol1/(fe_mol1+c_mol1)
		
		return
	  	end
c    *********************************************************************       
       
      subroutine lamda_crit_spa(teqm,temp,spac) 
      real spac,del_T,del_hm,teqm,del_vm,del_HV,del_G,lamda2

      del_HV=(-2E6*temp)+2E9
c      si_fc=(-0.0048*temp)+5.4218
      del_T=teqm-temp
      del_G=(8.09554e5*temp)-8.03332e08
      lamda2=1e-6/((-0.1627*temp)+162.74)
c      print *, 'The del_G and lamda2',del_G,lamda2
      spac=lamda2/(4.586e-35*exp(temp/12.8523)+2.03714)
      si_fc=-0.5*spac*del_G

c       print *,'the new spac and sigma is:',spac,si_fc
      return
      end
c    *********************************************************************
      subroutine lamella_thk(carbon,c_cem,c_fer,lamda,lamcem)
      real wt_frac_fer,vol_frac_fer,vol_frac_cem,r_fer,lamda,lamcem
      wt_frac_fer=(c_cem-carbon)/(c_cem-c_fer)
	  vol_frac_fer=wt_frac_fer	

c	  densities of ferrite and austenite are nearly same
	  vol_frac_cem=1-vol_frac_fer
	  r_fer=vol_frac_fer/vol_frac_cem
	  lamcem=lamda/(r_fer+1)
	 
	  return
      end  

c    *********************************************************************   
    
       subroutine phi_c(del_e,k2,temp,phi1)
        real k2,phi1
		phi1=1-exp( (-del_e)/(k2*temp) )
c		print *, 'the value of phi is :',phi
c		print *, 'the value of temp is :',temp
		return
        end
     
      
c    *********************************************************************

c FUNCTION GIVING THE DIFFERENTIAL OF NATURAL LOGARITHM (ACTIVITY OF CARBON IN AUSTENITE):
        subroutine DCG(var1_m,del_e,temp,R1,slope)
       real DG,DDG,var1_m,temp,slope,phi10
       R1=8.14
      
       phi10=1.0-EXP(-del_e/(R1*temp)) 
       DG=SQRT(1.0-2.0*(1.0+2.0*phi10)*var1_m+(1.0+8.0*phi10)*var1_m**2)
       DDG=(0.5/DG)*(-2.0-4.0*phi10+2.0*var1_m+16.0*phi10*var1_m)
       slope=-((10.0/(1.0-2.0*var1_m))+(5.0/var1_m))+6.0*((DDG+3.0)
     & /(DG-1.0+3.0*var1_m
     & )-(DDG-3.0)/(DG+1.0-3.0*var1_m))
       return
       end

c    *********************************************************************

C FUNCTION GIVING THE NATURAL LOGARITHM (ACTIVITY OF CARBON IN AUSTENITE):
      
       subroutine act_c(var1_m,temp,del_e,CG)
       real  var1_m,AJ,DG,EG,EG1,R,W,CG
       R=8.31

       
       AJ=1-EXP(-del_e/(R*temp))
          IF(var1_m .LE. 1.0e-10) THEN
            CG=LOG(1.0e-10)
          ELSE
            DG=SQRT(1.0-2.0*(1.0+2.0*AJ)*var1_m+(1.0+8.0*AJ)*var1_m**2)

            
            EG=5*LOG((1-2*var1_m)/var1_m)+6*del_e/(R*temp)
            EG1= (38575-13.48*temp)/(R*temp)
            
            CG=EG+EG1+6*LOG((DG-1+3*var1_m)/(DG+1-3*var1_m))
c           CG=exp(CG)
c            print *, 'the value of CG is:',CG
      	  ENDIF
          RETURN
          END 
c    ********************************************************************* 

C subroutine GIVING THE CARBON DIFFUSIVITY IN AUSTENITE:
       subroutine DIFF(temp,var1_m,var3_m,del_e,acti_c,slope,phi,d_avg)

       integer II,II2,II3
       real D(1000),CARB(1000)
       real X,THET,DASH,eta,R2,Z2,HH,KK,eta1,eta2,eta3,eta4,ans,d_avg
       real ACTI,DACTI,SIGMA,XINCR,var1_m,var3_m,acti_c,slope,phi,A5
       HH=6.6262e-34
       KK=1.38062e-23
       Z2=12
       A5=1.0
       R2=8.31
       

       DASH=(KK*temp/HH)*EXP(-(21230/temp))*EXP(-31.84)
       
       XINCR=(var1_m-var3_m)/5
     
       
       DO 111 II=1,5
         
        CARB(II)=var3_m+(II-1)*XINCR
        X=CARB(II)
        THET=X/(A5-X)
       
        
c       the var1,var3 and X are to be expressed in mol fractions.       

        ACTI=acti_c
      
        ACTI=EXP(ACTI)
		
		
        DACTI=slope
        DACTI=DACTI*ACTI
        DACTI=DACTI*A5/((A5+THET)**2)

        SIGMA=phi
      
        
        eta=A5+(Z2*(A5+THET))
        eta2=(A5-((A5+Z2/2)*THET)+(Z2/2)*(A5+Z2/2)*(A5-SIGMA)*THET**2)
        eta3=ACTI*(eta/eta2)
        eta1 =(A5+THET)*DACTI
        eta4=eta1+eta3
       
        D(II)=DASH*eta4
c        print *,'the dif coef in cm2/s and theta is:',D(II)
c        write(113,*), D(II), THET
  111 continue

       call TRAPE(var1_m,var3_m,XINCR,II,D,ans)
         
        d_avg=ans/(var1_m-var3_m)
     
       RETURN
       END
c    *********************************************************************
		 
		 subroutine TRAPE(var1_m,var3_m,XINCR,II,D,ans)
		 
		 real var1_m,var3_m,XINCR,XX,sum,D(1000),ans1,ans
         INTEGER Q,II
          sum=0
          do 999 Q=1,II-1
           XX=var3_m+(XINCR*Q)
           sum=sum+D(Q)
           
  999   continue
       ans=XINCR*( (D(1)+D(5)/2) + sum )

c      ans=ans1+ XINCR*((((2E-8)*var1_m)+1E-9)/2)

c       print *,'the value of avg. diff coef. is :',ans
       return
       end

c    *********************************************************************      		
      subroutine mixed_growth(temp,carbon,d_avg,res1,res2,velo) 	
      		real y5,spac2,dcgb3,dcgb4,dcgb5,velo1,velo2,velo,c_cem2,c_fer2,delta	
      		real molfra,wt_fe2,fe_mol2,c_mol2,carbon,lamda2,lamce2,lamfe2,teqm,u
      		c_cem2=6.67
      		c_fer2=0.025
      		teqm=1000
      		delta=2.5e-10
c      		print *, 'the teqm is:',teqm
      		call lamda_crit_spa(teqm,temp,spac2)  
			lamda2=1e-6/((-0.1627*temp)+162.74)
          
      		call lamella_thk(carbon,c_cem2,c_fer2,lamda2,lamce2)
      		lamfe2=lamda2-lamce2
      		print *, 'the S in m is:',lamda2
      		print *, 'the S_fer and S_cem in m are:',lamfe2,lamce2
      		
      		u=res1/res2
c      		print *,'res1/res 2 is:', u
      	 	
      	 	wt_fe2=100-carbon
			fe_mol2=wt_fe2/55.8
			c_mol2=carbon/12.01
			molfra=c_mol2/(fe_mol2+c_mol2)
      	 	
      	 	y5=molfra/(1-molfra)	
	        
c	        dcgb3 = 4.53E-7*(  1+(y5*(1-y5))*8339.9/temp)
            dcgb4 = 8.5133e-5*exp(-96851/(8.312*temp))
c       		dcgb4 = exp(-0.5* (( (1/temp)- 2.221E-4)*(17767-(26436*y5)) ))
c        	dcgb5 =dcgb3*dcgb4
            print *, 'The D_gb of carbon in m2 s-1 is:',dcgb4
            print *, 'The D_wei_avg of carbon in m2 s-1 is:',d_avg*1e-4
	        
	        velo1=((2*d_avg*0.0001)+(12*dcgb4*delta/lamda2))*lamda2
	        velo2=(1-(spac2/lamda2))*(res1/res2)/(lamfe2*lamce2)
	        velo=velo1*velo2
      
      		return
      		end
c    *********************************************************************      
      
      